diff --git a/gcc/analyzer/region-model.h b/gcc/analyzer/region-model.h
index 6d427c4c654..b00eabd8c48 100644
--- a/gcc/analyzer/region-model.h
+++ b/gcc/analyzer/region-model.h
@@ -944,101 +1438,142 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <region *>::test (region *)
+is_a_helper <const region *>::test (const region *)
 {
   return true;
 }
 
 namespace ana {
 
-/* Concrete region subclass for storing "primitive" types (integral types,
-   pointers, etc).  */
+/* Abstract subclass of region, for regions that represent an untyped
+   space within memory, such as the stack or the heap.  */
 
-class primitive_region : public region
+class space_region : public region
 {
-public:
-  primitive_region (region_id parent_rid, tree type)
-  : region (parent_rid, svalue_id::null (), type)
+protected:
+  space_region (unsigned id, const region *parent)
+  : region (complexity (parent), id, parent, NULL_TREE)
   {}
-
-  region *clone () const FINAL OVERRIDE;
-
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_PRIMITIVE; }
-
-  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
 };
 
-/* A region that has children identified by tree keys.
-   For example a stack frame has subregions per local, and a region
-   for a struct has subregions per field.  */
+/* Concrete space_region subclass, representing a function frame on the stack,
+   to contain the locals.
+   The parent is the stack region; there's also a hierarchy of call-stack
+   prefixes expressed via m_calling_frame.
+   For example, given "oldest" calling "middle" called "newest" we would have
+   - a stack depth of 3
+   - frame (A) for "oldest" with index 0 for depth 1, calling_frame == NULL
+   - frame (B) for "middle" with index 1 for depth 2, calling_frame == (A)
+   - frame (C) for "newest" with index 2 for depth 3, calling_frame == (B)
+   where the parent region for each of the frames is the "stack" region.
+   The index is the count of frames earlier than this in the stack.  */
 
-class map_region : public region
+class frame_region : public space_region
 {
 public:
-  typedef ordered_hash_map<tree, region_id> map_t;
-  typedef map_t::iterator iterator_t;
+  /* A support class for uniquifying instances of frame_region.  */
+  struct key_t
+  {
+    key_t (const frame_region *calling_frame, function *fun)
+    : m_calling_frame (calling_frame), m_fun (fun)
+    {
+      /* calling_frame can be NULL.  */
+      gcc_assert (fun);
+    }
 
-  map_region (region_id parent_rid, tree type)
-  : region (parent_rid, svalue_id::null (), type)
-  {}
-  map_region (const map_region &other);
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_calling_frame);
+      hstate.add_ptr (m_fun);
+      return hstate.end ();
+    }
 
-  map_region *dyn_cast_map_region () FINAL OVERRIDE { return this; }
+    bool operator== (const key_t &other) const
+    {
+      return (m_calling_frame == other.m_calling_frame && m_fun == other.m_fun);
+    }
 
-  void dump_dot_to_pp (const region_model &model,
-		       region_id this_rid,
-		       pretty_printer *pp) const
-    FINAL OVERRIDE;
+    void mark_deleted () { m_fun = reinterpret_cast<function *> (1); }
+    void mark_empty () { m_fun = NULL; }
+    bool is_deleted () const
+    {
+      return m_fun == reinterpret_cast<function *> (1);
+    }
+    bool is_empty () const { return m_fun == NULL; }
 
-  void dump_child_label (const region_model &model,
-			 region_id this_rid,
-			 region_id child_rid,
-			 pretty_printer *pp) const
-    FINAL OVERRIDE;
+    const frame_region *m_calling_frame;
+    function *m_fun;
+  };
 
-  region_id get_or_create (region_model *model,
-			   region_id this_rid,
-			   tree expr, tree type,
-			   region_model_context *ctxt);
-  void unbind (tree expr);
-  region_id *get (tree expr);
+  frame_region (unsigned id, const region *parent,
+		const frame_region *calling_frame,
+		function *fun, int index)
+  : space_region (id, parent), m_calling_frame (calling_frame),
+    m_fun (fun), m_index (index)
+  {}
+  ~frame_region ();
 
-  void remap_region_ids (const region_id_map &map) FINAL OVERRIDE;
+  /* region vfuncs.  */
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_FRAME; }
+  const frame_region * dyn_cast_frame_region () const FINAL OVERRIDE
+  {
+    return this;
+  }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  tree get_tree_for_child_region (region_id child_rid) const;
+  /* Accessors.  */
+  const frame_region *get_calling_frame () const { return m_calling_frame; }
+  function *get_function () const { return m_fun; }
+  int get_index () const { return m_index; }
+  int get_stack_depth () const { return m_index + 1; }
 
-  tree get_tree_for_child_region (region *child,
-				  const region_model &model) const;
+  const region *get_region_for_local (region_model_manager *mgr,
+				       tree expr) const;
 
-  static bool can_merge_p (const map_region *map_region_a,
-			   const map_region *map_region_b,
-			   map_region *merged_map_region,
-			   region_id merged_rid,
-			   model_merger *merger);
+  unsigned get_num_locals () const { return m_locals.elements (); }
 
-  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+ private:
+  const frame_region *m_calling_frame;
+  function *m_fun;
+  int m_index;
+  typedef hash_map<tree, region *> map_t;
+  map_t m_locals;
+  /* TODO: do we want a distinction between params (assumed initialized)
+     vs temporaries?  */
+};
+
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const frame_region *>::test (const region *reg)
+{
+  return reg->get_kind () == RK_FRAME;
+}
 
-  virtual bool valid_key_p (tree key) const = 0;
+template <> struct default_hash_traits<frame_region::key_t>
+: public member_function_hash_traits<frame_region::key_t>
+{
+  static const bool empty_zero_p = true;
+};
 
-  svalue_id get_value_by_name (tree identifier,
-			       const region_model &model) const;
+namespace ana {
 
-  iterator_t begin () { return m_map.begin (); }
-  iterator_t end () { return m_map.end (); }
-  size_t elements () const { return m_map.elements (); }
+/* Concrete space_region subclass, to hold global variables (data and bss).  */
 
- protected:
-  bool compare_fields (const map_region &other) const;
-  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
-  void print_fields (const region_model &model,
-		     region_id this_rid,
-		     pretty_printer *pp) const
-    OVERRIDE;
-  void validate (const region_model &model) const FINAL OVERRIDE;
+class globals_region : public space_region
+{
+ public:
+  globals_region (unsigned id, const region *parent)
+  : space_region (id, parent)
+  {}
 
- private:
-  /* Mapping from tree to child region.  */
-  map_t m_map;
+  /* region vfuncs.  */
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_GLOBALS; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 };
 
 } // namespace ana
@@ -1046,27 +1581,30 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <map_region *>::test (region *reg)
+is_a_helper <const globals_region *>::test (const region *reg)
 {
-  return (reg->dyn_cast_map_region () != NULL);
+  return reg->get_kind () == RK_GLOBALS;
 }
 
 namespace ana {
 
-/* Abstract subclass representing a region with fields
-   (either a struct or a union).  */
+/* Concrete space_region subclass, representing the code segment
+   containing functions.  */
 
-class struct_or_union_region : public map_region
+class code_region : public space_region
 {
 public:
-  bool valid_key_p (tree key) const FINAL OVERRIDE;
-
- protected:
-  struct_or_union_region (region_id parent_rid, tree type)
-  : map_region (parent_rid, type)
+  code_region (unsigned id, const region *parent)
+  : space_region (id, parent)
   {}
 
-  bool compare_fields (const struct_or_union_region &other) const;
+  /* region vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_CODE; }
+
+  const region *get_element (region_model *model,
+			const svalue *index,
+			region_model_context *ctxt);
 };
 
 } // namespace ana
@@ -1074,31 +1612,40 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <struct_or_union_region *>::test (region *reg)
+is_a_helper <const code_region *>::test (const region *reg)
 {
-  return (reg->get_kind () == RK_STRUCT
-	  || reg->get_kind () == RK_UNION);
+  return reg->get_kind () == RK_CODE;
 }
 
 namespace ana {
 
-/* Concrete region subclass.  A map_region representing a struct, using
-   FIELD_DECLs for its keys.  */
+/* Concrete region subclass.  A region representing the code for
+   a particular function.  */
 
-class struct_region : public struct_or_union_region
+class function_region : public region
 {
 public:
-  struct_region (region_id parent_rid, tree type)
-  : struct_or_union_region (parent_rid, type)
+  function_region (unsigned id, const code_region *parent, tree fndecl)
+  : region (complexity (parent), id, parent, TREE_TYPE (fndecl)),
+    m_fndecl (fndecl)
   {
-    gcc_assert (TREE_CODE (type) == RECORD_TYPE);
+    gcc_assert (FUNC_OR_METHOD_TYPE_P (TREE_TYPE (fndecl)));
   }
 
-  region *clone () const FINAL OVERRIDE;
+  /* region vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_FUNCTION; }
+  const function_region *
+  dyn_cast_function_region () const FINAL OVERRIDE{ return this; }
+
+  tree get_fndecl () const { return m_fndecl; }
 
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_STRUCT; }
+  region *get_element (region_model *model,
+			const svalue *index_sid,
+			region_model_context *ctxt);
 
-  bool compare_fields (const struct_region &other) const;
+private:
+  tree m_fndecl;
 };
 
 } // namespace ana
@@ -1106,30 +1653,31 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <struct_region *>::test (region *reg)
+is_a_helper <const function_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_STRUCT;
+  return reg->get_kind () == RK_FUNCTION;
 }
 
 namespace ana {
 
-/* Concrete region subclass.  A map_region representing a union, using
-   FIELD_DECLs for its keys.  */
+/* Concrete region subclass.  A region representing a particular label
+   within a function.  */
 
-class union_region : public struct_or_union_region
+class label_region : public region
 {
 public:
-  union_region (region_id parent_rid, tree type)
-  : struct_or_union_region (parent_rid, type)
+  label_region (unsigned id, const function_region *parent, tree label)
+  : region (complexity (parent), id, parent, NULL_TREE), m_label (label)
   {
-    gcc_assert (TREE_CODE (type) == UNION_TYPE);
+    gcc_assert (TREE_CODE (label) == LABEL_DECL);
   }
 
-  region *clone () const FINAL OVERRIDE;
-
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_UNION; }
+  /* region vfuncs.  */
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_LABEL; }
 
-  bool compare_fields (const union_region &other) const;
+private:
+  tree m_label;
 };
 
 } // namespace ana
@@ -1137,69 +1685,77 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <union_region *>::test (region *reg)
+is_a_helper <const label_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_UNION;
+  return reg->get_kind () == RK_LABEL;
 }
 
 namespace ana {
 
-/* Abstract map_region subclass for accessing decls, used as a base class
-   for function frames and for the globals region.  */
+/* Concrete space_region subclass representing a stack, containing all stack
+   frames.  */
 
-class scope_region : public map_region
+class stack_region : public space_region
 {
- public:
-
- protected:
-  scope_region (region_id parent_rid)
-  : map_region (parent_rid, NULL_TREE)
+public:
+  stack_region (unsigned id, region *parent)
+  : space_region (id, parent)
   {}
 
-  scope_region (const scope_region &other)
-  : map_region (other)
-  {
-  }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  bool compare_fields (const scope_region &other) const;
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_STACK; }
 };
 
-/* Concrete region subclass, representing a function frame on the stack,
-   to contain the locals.  */
+} // namespace ana
+
+template <>
+template <>
+inline bool
+is_a_helper <const stack_region *>::test (const region *reg)
+{
+  return reg->get_kind () == RK_STACK;
+}
 
-class frame_region : public scope_region
+namespace ana {
+
+/* Concrete space_region subclass: a region within which regions can be
+   dynamically allocated.  */
+
+class heap_region : public space_region
 {
 public:
-  frame_region (region_id parent_rid, function *fun, int depth)
-  : scope_region (parent_rid), m_fun (fun), m_depth (depth)
+  heap_region (unsigned id, region *parent)
+  : space_region (id, parent)
   {}
 
-  frame_region (const frame_region &other)
-  : scope_region (other), m_fun (other.m_fun), m_depth (other.m_depth)
-  {
-  }
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_HEAP; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+};
 
-  /* region vfuncs.  */
-  region *clone () const FINAL OVERRIDE;
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_FRAME; }
-  void print_fields (const region_model &model,
-		     region_id this_rid,
-		     pretty_printer *pp) const
-    FINAL OVERRIDE;
-  void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
+} // namespace ana
 
-  /* map_region vfuncs.  */
-  bool valid_key_p (tree key) const FINAL OVERRIDE;
+template <>
+template <>
+inline bool
+is_a_helper <const heap_region *>::test (const region *reg)
+{
+  return reg->get_kind () == RK_HEAP;
+}
 
-  /* Accessors.  */
-  function *get_function () const { return m_fun; }
-  int get_depth () const { return m_depth; }
+namespace ana {
 
-  bool compare_fields (const frame_region &other) const;
+/* Concrete region subclass.  The root region, containing all regions
+   (either directly, or as descendents).
+   Unique within a region_model_manager.  */
 
- private:
-  function *m_fun;
-  int m_depth;
+class root_region : public region
+{
+public:
+  root_region (unsigned id);
+
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_ROOT; }
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 };
 
 } // namespace ana
@@ -1207,35 +1763,70 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <frame_region *>::test (region *reg)
+is_a_helper <const root_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_FRAME;
+  return reg->get_kind () == RK_ROOT;
 }
 
 namespace ana {
 
-/* Concrete region subclass, to hold global variables (data and bss).  */
+/* Concrete region subclass: a region to use when dereferencing an unknown
+   pointer.  */
 
-class globals_region : public scope_region
+class symbolic_region : public region
 {
- public:
-  globals_region (region_id parent_rid)
-  : scope_region (parent_rid)
+public:
+  /* A support class for uniquifying instances of symbolic_region.  */
+  struct key_t
+  {
+    key_t (const region *parent, const svalue *sval_ptr)
+    : m_parent (parent), m_sval_ptr (sval_ptr)
+    {
+      gcc_assert (sval_ptr);
+    }
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_parent);
+      hstate.add_ptr (m_sval_ptr);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_parent == other.m_parent && m_sval_ptr == other.m_sval_ptr);
+    }
+
+    void mark_deleted () { m_sval_ptr = reinterpret_cast<const svalue *> (1); }
+    void mark_empty () { m_sval_ptr = NULL; }
+    bool is_deleted () const
+    {
+      return m_sval_ptr == reinterpret_cast<const svalue *> (1);
+    }
+    bool is_empty () const { return m_sval_ptr == NULL; }
+
+    const region *m_parent;
+    const svalue *m_sval_ptr;
+  };
+
+  symbolic_region (unsigned id, region *parent, const svalue *sval_ptr)
+  : region (complexity::from_pair (parent, sval_ptr), id, parent,
+	    TREE_TYPE (sval_ptr->get_type ())),
+    m_sval_ptr (sval_ptr)
   {}
 
-  globals_region (const globals_region &other)
-  : scope_region (other)
-  {
-  }
+  const symbolic_region *
+  dyn_cast_symbolic_region () const FINAL OVERRIDE { return this; }
 
-  /* region vfuncs.  */
-  region *clone () const FINAL OVERRIDE;
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_GLOBALS; }
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_SYMBOLIC; }
+  void accept (visitor *v) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  /* map_region vfuncs.  */
-  bool valid_key_p (tree key) const FINAL OVERRIDE;
+  const svalue *get_pointer () const { return m_sval_ptr; }
 
-  bool compare_fields (const globals_region &other) const;
+private:
+  const svalue *m_sval_ptr;
 };
 
 } // namespace ana
@@ -1243,39 +1834,40 @@ class globals_region : public scope_region
 template <>
 template <>
 inline bool
-is_a_helper <globals_region *>::test (region *reg)
+is_a_helper <const symbolic_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_GLOBALS;
+  return reg->get_kind () == RK_SYMBOLIC;
 }
 
+template <> struct default_hash_traits<symbolic_region::key_t>
+: public member_function_hash_traits<symbolic_region::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
 namespace ana {
 
-/* Concrete region subclass.  A map_region representing the code, using
-   FUNCTION_DECLs for its keys.  */
+/* Concrete region subclass representing the memory occupied by a
+   variable (whether for a global or a local).  */
 
-class code_region : public map_region
+class decl_region : public region
 {
 public:
-  code_region (region_id parent_rid)
-  : map_region (parent_rid, NULL_TREE)
-  {}
-  code_region (const code_region &other)
-  : map_region (other)
+  decl_region (unsigned id, const region *parent, tree decl)
+  : region (complexity (parent), id, parent, TREE_TYPE (decl)), m_decl (decl)
   {}
 
-  /* region vfuncs.  */
-  region *clone () const FINAL OVERRIDE;
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_CODE; }
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_DECL; }
+  const decl_region *
+  dyn_cast_decl_region () const FINAL OVERRIDE { return this; }
 
-  /* map_region vfunc.  */
-  bool valid_key_p (tree key) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
-  region_id get_element (region_model *model,
-			 region_id this_rid,
-			 svalue_id index_sid,
-			 region_model_context *ctxt);
+  tree get_decl () const { return m_decl; }
+  int get_stack_depth () const;
 
-  bool compare_fields (const code_region &other) const;
+private:
+  tree m_decl;
 };
 
 } // namespace ana
@@ -1283,41 +1875,65 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <code_region *>::test (region *reg)
+is_a_helper <const decl_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_CODE;
+  return reg->get_kind () == RK_DECL;
 }
 
 namespace ana {
 
-/* Concrete region subclass.  A map_region representing the code for
-   a particular function, using LABEL_DECLs for its keys.  */
+/* Concrete region subclass representing the memory occupied by a
+   field within a struct or union.  */
 
-class function_region : public map_region
+class field_region : public region
 {
 public:
-  function_region (region_id parent_rid, tree type)
-  : map_region (parent_rid, type)
+  /* A support class for uniquifying instances of field_region.  */
+  struct key_t
   {
-    gcc_assert (FUNC_OR_METHOD_TYPE_P (type));
-  }
-  function_region (const function_region &other)
-  : map_region (other)
+    key_t (const region *parent, tree field)
+    : m_parent (parent), m_field (field)
+    {
+      gcc_assert (field);
+    }
+
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_parent);
+      hstate.add_ptr (m_field);
+      return hstate.end ();
+    }
+
+    bool operator== (const key_t &other) const
+    {
+      return (m_parent == other.m_parent && m_field == other.m_field);
+    }
+
+    void mark_deleted () { m_field = reinterpret_cast<tree> (1); }
+    void mark_empty () { m_field = NULL_TREE; }
+    bool is_deleted () const { return m_field == reinterpret_cast<tree> (1); }
+    bool is_empty () const { return m_field == NULL_TREE; }
+
+    const region *m_parent;
+    tree m_field;
+  };
+
+  field_region (unsigned id, const region *parent, tree field)
+  : region (complexity (parent), id, parent, TREE_TYPE (field)),
+    m_field (field)
   {}
 
-  /* region vfuncs.  */
-  region *clone () const FINAL OVERRIDE;
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_FUNCTION; }
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_FIELD; }
 
-  /* map_region vfunc.  */
-  bool valid_key_p (tree key) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
+  const field_region *
+  dyn_cast_field_region () const FINAL OVERRIDE { return this; }
 
-  region_id get_element (region_model *model,
-			 region_id this_rid,
-			 svalue_id index_sid,
-			 region_model_context *ctxt);
+  tree get_field () const { return m_field; }
 
-  bool compare_fields (const function_region &other) const;
+private:
+  tree m_field;
 };
 
 } // namespace ana
@@ -1325,109 +1941,80 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <function_region *>::test (region *reg)
+is_a_helper <const field_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_FUNCTION;
+  return reg->get_kind () == RK_FIELD;
 }
 
+template <> struct default_hash_traits<field_region::key_t>
+: public member_function_hash_traits<field_region::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
 namespace ana {
 
-/* Concrete region subclass representing an array (or an array-like view
-   of a parent region of memory.
-   This can't be a map_region as we can't use trees as the keys: there's
-   no guarantee about the uniqueness of an INTEGER_CST.  */
+/* An element within an array.  */
 
-class array_region : public region
+class element_region : public region
 {
 public:
-#if 0
-  wide_int m_test;
-
-  typedef wide_int key_t;
-  typedef int_hash <wide_int, -1, -2> hash_t;
-  typedef ordered_hash_map<hash_t, region_id> map_t;
-#else
-  typedef int key_t;
-  typedef int_hash <int, -1, -2> int_hash_t;
-  typedef ordered_hash_map<int_hash_t, region_id> map_t;
-#endif
-  typedef map_t::iterator iterator_t;
-
-  array_region (region_id parent_rid, tree type)
-  : region (parent_rid, svalue_id::null (), type)
+  /* A support class for uniquifying instances of element_region.  */
+  struct key_t
   {
-    gcc_assert (TREE_CODE (type) == ARRAY_TYPE);
-  }
-  array_region (const array_region &other);
-
-  void dump_dot_to_pp (const region_model &model,
-		       region_id this_rid,
-		       pretty_printer *pp) const
-    FINAL OVERRIDE;
-
-  void dump_child_label (const region_model &model,
-			 region_id this_rid,
-			 region_id child_rid,
-			 pretty_printer *pp) const
-    FINAL OVERRIDE;
-
-  /* region vfuncs.  */
-  region *clone () const FINAL OVERRIDE;
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_ARRAY; }
-  array_region *dyn_cast_array_region () { return this; }
-
-  region_id get_element (region_model *model,
-			 region_id this_rid,
-			 svalue_id index_sid,
-			 region_model_context *ctxt);
-
-  bool compare_fields (const array_region &other) const;
-
-  static bool can_merge_p (const array_region *array_region_a,
-			   const array_region *array_region_b,
-			   array_region *merged_array_region,
-			   region_id merged_rid,
-			   model_merger *merger);
+    key_t (const region *parent, tree element_type, const svalue *index)
+    : m_parent (parent), m_element_type (element_type), m_index (index)
+    {
+      gcc_assert (index);
+    }
 
-  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_parent);
+      hstate.add_ptr (m_element_type);
+      hstate.add_ptr (m_index);
+      return hstate.end ();
+    }
 
-  iterator_t begin () { return m_map.begin (); }
-  iterator_t end () { return m_map.end (); }
-  size_t elements () const { return m_map.elements (); }
+    bool operator== (const key_t &other) const
+    {
+      return (m_parent == other.m_parent
+	      && m_element_type == other.m_element_type
+	      && m_index == other.m_index);
+    }
 
-  region_id get_or_create (region_model *model,
-			   region_id this_rid,
-			   key_t key, tree type,
-			   region_model_context *ctxt);
-//  void unbind (int expr);
-  region_id *get (key_t key);
+    void mark_deleted () { m_index = reinterpret_cast<const svalue *> (1); }
+    void mark_empty () { m_index = NULL; }
+    bool is_deleted () const
+    {
+      return m_index == reinterpret_cast<const svalue *> (1);
+    }
+    bool is_empty () const { return m_index == NULL; }
 
-  void remap_region_ids (const region_id_map &map) FINAL OVERRIDE;
+    const region *m_parent;
+    tree m_element_type;
+    const svalue *m_index;
+  };
 
-  bool get_key_for_child_region (region_id child_rid,
-				 key_t *out) const;
+  element_region (unsigned id, const region *parent, tree element_type,
+		  const svalue *index)
+  : region (complexity::from_pair (parent, index), id, parent, element_type),
+    m_index (index)
+  {}
 
-#if 0
-  bool get_key_for_child_region (region *child,
-				 const region_model &model,
-				 key_t *out) const;
-#endif
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_ELEMENT; }
+  const element_region *
+  dyn_cast_element_region () const FINAL OVERRIDE { return this; }
 
-  void add_to_hash (inchash::hash &hstate) const OVERRIDE;
-  void print_fields (const region_model &model,
-		     region_id this_rid,
-		     pretty_printer *pp) const
-    OVERRIDE;
-  void validate (const region_model &model) const FINAL OVERRIDE;
+  void accept (visitor *v) const FINAL OVERRIDE;
 
-  static key_t key_from_constant (tree cst);
-  tree constant_from_key (key_t key);
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
- private:
-  static int key_cmp (const void *, const void *);
+  const svalue *get_index () const { return m_index; }
 
-  /* Mapping from tree to child region.  */
-  map_t m_map;
+private:
+  const svalue *m_index;
 };
 
 } // namespace ana
@@ -1435,68 +2022,81 @@ public:
 template <>
 template <>
 inline bool
-is_a_helper <array_region *>::test (region *reg)
+is_a_helper <const element_region *>::test (const region *reg)
 {
-  return reg->get_kind () == RK_ARRAY;
+  return reg->get_kind () == RK_ELEMENT;
 }
 
+template <> struct default_hash_traits<element_region::key_t>
+: public member_function_hash_traits<element_region::key_t>
+{
+  static const bool empty_zero_p = true;
+};
+
 namespace ana {
 
-/* Concrete region subclass representing a stack, containing all stack
-   frames, and implicitly providing a POISON_KIND_UNINIT value to all
-   child regions by default.  */
+/* A byte-offset within another region, for handling pointer arithmetic
+   as a region.  */
 
-class stack_region : public region
+class offset_region : public region
 {
 public:
-  stack_region (region_id parent_rid, svalue_id sval_id)
-  : region (parent_rid, sval_id, NULL_TREE)
-  {}
-
-  stack_region (const stack_region &other);
-
-  bool compare_fields (const stack_region &other) const;
-
-  region *clone () const FINAL OVERRIDE;
-
-  enum region_kind get_kind () const FINAL OVERRIDE { return RK_STACK; }
+  /* A support class for uniquifying instances of offset_region.  */
+  struct key_t
+  {
+    key_t (const region *parent, tree element_type, const svalue *byte_offset)
+    : m_parent (parent), m_element_type (element_type), m_byte_offset (byte_offset)
+    {
+      gcc_assert (byte_offset);
+    }
 
-  void dump_child_label (const region_model &model,
-			 region_id this_rid,
-			 region_id child_rid,
-			 pretty_printer *pp) const
-    FINAL OVERRIDE;
+    hashval_t hash () const
+    {
+      inchash::hash hstate;
+      hstate.add_ptr (m_parent);
+      hstate.add_ptr (m_element_type);
+      hstate.add_ptr (m_byte_offset);
+      return hstate.end ();
+    }
 
-  void push_frame (region_id frame_rid);
-  region_id get_current_frame_id () const;
-  void pop_frame (region_model *model, region_id result_dst_rid,
-		  bool purge, purge_stats *stats,
-		  region_model_context *ctxt);
+    bool operator== (const key_t &other) const
+    {
+      return (m_parent == other.m_parent
+	      && m_element_type == other.m_element_type
+	      && m_byte_offset == other.m_byte_offset);
+    }
 
-  void remap_region_ids (const region_id_map &map) FINAL OVERRIDE;
+    void mark_deleted () { m_byte_offset = reinterpret_cast<const svalue *> (1); }
+    void mark_empty () { m_byte_offset = NULL; }
+    bool is_deleted () const
+    {
+      return m_byte_offset == reinterpret_cast<const svalue *> (1);
+    }
+    bool is_empty () const { return m_byte_offset == NULL; }
 
-  unsigned get_num_frames () const { return m_frame_rids.length (); }
-  region_id get_frame_rid (unsigned i) const { return m_frame_rids[i]; }
+    const region *m_parent;
+    tree m_element_type;
+    const svalue *m_byte_offset;
+  };
 
-  static bool can_merge_p (const stack_region *stack_region_a,
-			   const stack_region *stack_region_b,
-			   model_merger *merger);
+  offset_region (unsigned id, const region *parent, tree type,
+		 const svalue *byte_offset)
+  : region (complexity::from_pair (parent, byte_offset), id, parent, type),
+    m_byte_offset (byte_offset)
+  {}
 
-  void walk_for_canonicalization (canonicalization *c) const FINAL OVERRIDE;
+  enum region_kind get_kind () const FINAL OVERRIDE { return RK_OFFSET; }
+  const offset_region *
+  dyn_cast_offset_region () const FINAL OVERRIDE { return this; }
 
-  svalue_id get_value_by_name (tree identifier,
-			       const region_model &model) const;
+  void accept (visitor *v) const FINAL OVERRIDE;
 
-  void validate (const region_model &model) const FINAL OVERRIDE;
+  void dump_to_pp (pretty_printer *pp, bool simple) const FINAL OVERRIDE;
 
- private:
-  void add_to_hash (inchash::hash &hstate) const FINAL OVERRIDE;
-  void print_fields (const region_model &model,
-		     region_id this_rid,
-		     pretty_printer *pp) const
-    FINAL OVERRIDE;
+  const svalue *get_byte_offset () const { return m_byte_offset; }
 
-  auto_vec<region_id> m_frame_rids;
+private:
+  const svalue *m_byte_offset;
 };
 
 } // namespace ana
